#include<iostream>
#include <list>
#include <math.h>
#include <matrix.h>
#include <mex.h>
#include <iostream>     // std::cout
#include <algorithm>    // std::max
#include <stdio.h>      // sin
#define PI 3.1415926535897932
#include <cmath>
#include <vector>

//using namespace std;

void mexFunction(int nlhs, mxArray *plhs[],
        int nrhs, const mxArray *prhs[]) {
    double *T;
    double *Dt;
    int i;
    int j;
    int k;
    int N;
    int NT;
    int m;
    int mu;
    double *Out;
    T = mxGetPr(prhs[0]);
    Dt = mxGetPr(prhs[1]);
    m = mxGetN(prhs[1]);
    int *D = new int[m];
    int *I = new int[m];
    int *Sx = new int[m];
    N = 0;
    NT = 1;
    Sx[0]=0;
    plhs[0] = mxCreateDoubleMatrix(1,1,mxREAL);
    Out = mxGetPr(plhs[0]);
    for(i=0;i<m;++i){
        D[i] = static_cast<int>(Dt[i]);
        N = N+D[i];
        NT = NT*D[i];
        I[i]=0;
        if(i<m-1){
            Sx[i+1]=Sx[i]+D[i];
        }
    }
    int *A = new int[N*N];
    // Creation of the graph
    for(i=0;i<N*N;++i){
        A[i]=0;
    }
    for(i=0 ; i<NT ; ++i){
        if(T[i]>0){
            for(j=0;j<m-1;++j){
                for(k=j+1;k<m;++k){
                    A[(Sx[j]+I[j])*N+Sx[k]+I[k]]=1;
                    A[(Sx[k]+I[k])*N+Sx[j]+I[j]]=1;
                    
                }
            }
        }
        I[0]=I[0]+1;
        mu=0;
        while(I[mu]==D[mu] && mu<m){
            I[mu]=0;
            if(mu+1<m){
                I[mu+1]=I[mu+1]+1;
            }
            mu=mu+1;
        }
    }
    /*
      for(i=0;i<N;++i){
      for(j=0;j<N;++j){
      printf(" %i ",A[i*N+j]);
      }
      printf("\n");
      }
     */
    
    
    // Determine connectivity using BFS (Breakfast Search)
    int *visited = new int[N];
    int *Queue = new int[N];
    for(i=0;i<N;++i){
        visited[i]=0;
        Queue[i]=-1;
    }
    int nu;
    nu = 0;
    int currentnode =0;
    visited[0]=1;
    for(i=0;i<N;++i){
        if(A[currentnode*N+i]==1){
            Queue[nu]=i;
            visited[i]=1;
            nu=nu+1;
        }
    }
    while(nu>0){
        currentnode=Queue[0];
        for(i=0;i<nu;++i){
            Queue[i]=Queue[i+1];
        }
        nu = nu-1;
        for(i=0;i<N;++i){
            if(A[currentnode*N+i]==1){
                if(visited[i]==0){
                    Queue[nu]=i;
                    visited[i]=1;
                    nu=nu+1;
                }
            }
        }
    }
    Out[0] = 1;
    for(i=0;i<N;++i){
        if(visited[i]==0){
            Out[0] = 0;
        }
    }
    delete[] D;
    delete[] I;
    delete[] Sx;
    delete[] A;
    delete[] Queue;
    delete[] visited;
}

